/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  TransactionMessage,
  TransactionMessageFromJSON,
  TransactionMessageFromJSONTyped,
  TransactionMessageToJSON,
} from './TransactionMessage';
import {
  TransactionMessageCollateralDto,
  TransactionMessageCollateralDtoFromJSON,
  TransactionMessageCollateralDtoFromJSONTyped,
  TransactionMessageCollateralDtoToJSON,
} from './TransactionMessageCollateralDto';

/**
 *
 * @export
 * @interface TransactionDto
 */
export interface TransactionDto {
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  id: string;
  /**
   *
   * @type {number}
   * @memberof TransactionDto
   */
  version?: number;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  senderBic: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  recipientBic: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  counterPartyBic: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  senderAccount: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  senderXdcAddress: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  recipientAccount: string;
  /**
   *
   * @type {number}
   * @memberof TransactionDto
   */
  amount: number;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  currency: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  direction: TransactionDtoDirectionEnum;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  status: TransactionDtoStatusEnum;
  /**
   *
   * @type {Date}
   * @memberof TransactionDto
   */
  requestDate: Date;
  /**
   *
   * @type {Date}
   * @memberof TransactionDto
   */
  validUntil: Date;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  endToEndId: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  referenceInfo?: string;
  /**
   *
   * @type {TransactionMessageCollateralDto}
   * @memberof TransactionDto
   */
  collateral?: TransactionMessageCollateralDto;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  initiator?: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  responder?: string;
  /**
   *
   * @type {string}
   * @memberof TransactionDto
   */
  rollupTransactionHash?: string;
  /**
   * Transaction messages if included in the response
   * @type {Array<TransactionMessage>}
   * @memberof TransactionDto
   */
  messages: Array<TransactionMessage>;
}

/**
 * @export
 */
export const TransactionDtoDirectionEnum = {
  Inbox: 'INBOX',
  Outbox: 'OUTBOX',
} as const;
export type TransactionDtoDirectionEnum =
  typeof TransactionDtoDirectionEnum[keyof typeof TransactionDtoDirectionEnum];

/**
 * @export
 */
export const TransactionDtoStatusEnum = {
  New: 'New',
  Requested: 'Requested',
  Received: 'Received',
  Approved: 'Approved',
  Rejected: 'Rejected',
  Expired: 'Expired',
  Failed: 'Failed',
} as const;
export type TransactionDtoStatusEnum =
  typeof TransactionDtoStatusEnum[keyof typeof TransactionDtoStatusEnum];

export function TransactionDtoFromJSON(json: any): TransactionDto {
  return TransactionDtoFromJSONTyped(json, false);
}

export function TransactionDtoFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransactionDto {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    id: json['id'],
    version: !exists(json, 'version') ? undefined : json['version'],
    senderBic: json['senderBic'],
    recipientBic: json['recipientBic'],
    counterPartyBic: json['counterPartyBic'],
    senderAccount: json['senderAccount'],
    senderXdcAddress: json['senderXdcAddress'],
    recipientAccount: json['recipientAccount'],
    amount: json['amount'],
    currency: json['currency'],
    direction: json['direction'],
    status: json['status'],
    requestDate: new Date(json['requestDate']),
    validUntil: new Date(json['validUntil']),
    endToEndId: json['endToEndId'],
    referenceInfo: !exists(json, 'referenceInfo')
      ? undefined
      : json['referenceInfo'],
    collateral: !exists(json, 'collateral')
      ? undefined
      : TransactionMessageCollateralDtoFromJSON(json['collateral']),
    initiator: !exists(json, 'initiator') ? undefined : json['initiator'],
    responder: !exists(json, 'responder') ? undefined : json['responder'],
    rollupTransactionHash: !exists(json, 'rollupTransactionHash')
      ? undefined
      : json['rollupTransactionHash'],
    messages: (json['messages'] as Array<any>).map(TransactionMessageFromJSON),
  };
}

export function TransactionDtoToJSON(value?: TransactionDto | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    id: value.id,
    version: value.version,
    senderBic: value.senderBic,
    recipientBic: value.recipientBic,
    counterPartyBic: value.counterPartyBic,
    senderAccount: value.senderAccount,
    senderXdcAddress: value.senderXdcAddress,
    recipientAccount: value.recipientAccount,
    amount: value.amount,
    currency: value.currency,
    direction: value.direction,
    status: value.status,
    requestDate: value.requestDate.toISOString(),
    validUntil: value.validUntil.toISOString(),
    endToEndId: value.endToEndId,
    referenceInfo: value.referenceInfo,
    collateral: TransactionMessageCollateralDtoToJSON(value.collateral),
    initiator: value.initiator,
    responder: value.responder,
    rollupTransactionHash: value.rollupTransactionHash,
    messages: (value.messages as Array<any>).map(TransactionMessageToJSON),
  };
}
